/****************************************************************************\
  FILE..........: tl30p_vc.h
  COPYRIGHT.....: Copyright(c) 1995, Bennet-Tec Information Systems
  VERSION.......: 3.99
  DESCRIPTION...: This source code is a supplement to the
                  TList 3.0 VBX. (professional version)
\****************************************************************************/
#ifndef TL30P_VC_H
#define TL30P_VC_H

//
// Properties' constants
//
enum
{
  /* 0000 */ IPROP_TLIST_CTLNAME,
  /* 0001 */ IPROP_TLIST_INDEX,
  /* 0002 */ IPROP_TLIST_TAG,
  /* 0003 */ IPROP_TLIST_LEFT,
  /* 0004 */ IPROP_TLIST_TOP,
  /* 0005 */ IPROP_TLIST_WIDTH,
  /* 0006 */ IPROP_TLIST_HEIGHT,
  /* 0007 */ IPROP_TLIST_FONTBOLD,
  /* 0008 */ IPROP_TLIST_FONTITALIC,
  /* 0009 */ IPROP_TLIST_FONTNAME,
  /* 0010 */ IPROP_TLIST_FONTSIZE,
  /* 0011 */ IPROP_TLIST_FONTSTRIKE,
  /* 0012 */ IPROP_TLIST_FONTUNDER,
  /* 0013 */ IPROP_TLIST_HWND,
  /* 0014 */ IPROP_TLIST_HELPCONTEXTID,
  /* 0015 */ IPROP_TLIST_ALIGN,
  /* 0016 */ IPROP_TLIST_FORECOLOR,
  /* 0017 */ IPROP_TLIST_BACKCOLOR,
  /* 0018 */ IPROP_TLIST_BORDERSTYLEON,
  /* 0019 */ IPROP_TLIST_DRAGICON,
  /* 0020 */ IPROP_TLIST_DRAGMODE,
  /* 0021 */ IPROP_TLIST_ENABLED,
  /* 0022 */ IPROP_TLIST_MOUSEPOINTER,
  /* 0023 */ IPROP_TLIST_TABINDEX,
  /* 0024 */ IPROP_TLIST_VISIBLE,
  /* 0025 */ IPROP_TLIST_IMAGESTRETCH,
  /* 0026 */ IPROP_TLIST_ITEMHEIGHT,//obsolete
  /* 0027 */ IPROP_TLIST_INVSTYLE,
  /* 0028 */ IPROP_TLIST_VIEWSTYLE,
  /* 0029 */ IPROP_TLIST_SHIFTSTEP,
  /* 0030 */ IPROP_TLIST_IMAGEDEFHEIGHT,
  /* 0031 */ IPROP_TLIST_IMAGEDEFWIDTH,
  /* 0032 */ IPROP_TLIST_LISTCOUNT,
  /* 0033 */ IPROP_TLIST_LISTINDEX,
  /* 0034 */ IPROP_TLIST_REDRAW,
  /* 0035 */ IPROP_TLIST_ABOUT,
  /* 0036 */ IPROP_TLIST_MULTISELECT,
  /* 0037 */ IPROP_TLIST_SELECTED,
  /* 0038 */ IPROP_TLIST_LIST,
  /* 0039 */ IPROP_TLIST_IMAGE,
  /* 0040 */ IPROP_TLIST_INVIMAGE,
  /* 0041 */ IPROP_TLIST_ITEMBACKCOLOR,
  /* 0042 */ IPROP_TLIST_ITEMFORECOLOR,
  /* 0043 */ IPROP_TLIST_ITEMFONTNAME,
  /* 0044 */ IPROP_TLIST_ITEMFONTSIZE,
  /* 0045 */ IPROP_TLIST_ITEMFONTBOLD,
  /* 0046 */ IPROP_TLIST_ITEMFONTITALIC,
  /* 0047 */ IPROP_TLIST_ITEMFONTSTRIKE,
  /* 0048 */ IPROP_TLIST_ITEMFONTUNDER,
  /* 0049 */ IPROP_TLIST_SHIFT,
  /* 0050 */ IPROP_TLIST_FULLPATH,
  /* 0051 */ IPROP_TLIST_PICTURETYPE,
  /* 0052 */ IPROP_TLIST_EXPAND,
  /* 0053 */ IPROP_TLIST_PATHSEPARATOR,
  /* 0054 */ IPROP_TLIST_TOPINDEX,
  /* 0055 */ IPROP_TLIST_HASSUBITEMS,
  /* 0056 */ IPROP_TLIST_ISITEMVISIBLE,
  /* 0057 */ IPROP_TLIST_PICTUREROOT,
  /* 0058 */ IPROP_TLIST_PICTUREOPEN,
  /* 0059 */ IPROP_TLIST_PICTURECLOSED,
  /* 0060 */ IPROP_TLIST_PICTURELEAF,
  /* 0061 */ IPROP_TLIST_PICTUREINVERTED,
  /* 0062 */ IPROP_TLIST_CURINDEXMETHOD,
  /* 0063 */ IPROP_TLIST_SELFORECOLOR,
  /* 0064 */ IPROP_TLIST_SELBACKCOLOR,
  /* 0065 */ IPROP_TLIST_INSERTITEM,
  /* 0066 */ IPROP_TLIST_NOINTEGRALHEIGHT,
  /* 0067 */ IPROP_TLIST_DISABLENOSCROLL,
  /* 0068 */ IPROP_TLIST_WIDTHOFTEXT,
  /* 0069 */ IPROP_TLIST_ITEMMULTILINE,
  /* 0070 */ IPROP_TLIST_CURRENTITEM,
  /* 0071 */ IPROP_TLIST_DRAGHIGHLIGHT,
  /* 0072 */ IPROP_TLIST_SHOWCHILDREN,
  /* 0073 */ IPROP_TLIST_COERCEINDEX,
  /* 0074 */ IPROP_TLIST_DROPTARGET,
  /* 0075 */ IPROP_TLIST_ITEMTYPE,
  /* 0076 */ IPROP_TLIST_ITEMINTVALUE,
  /* 0077 */ IPROP_TLIST_ITEMLNGVALUE,
  /* 0078 */ IPROP_TLIST_ITEMSNGVALUE,
  /* 0079 */ IPROP_TLIST_ITEMSTRVALUE,
  /* 0080 */ IPROP_TLIST_ADD,
  /* 0081 */ IPROP_TLIST_INSERT,
  /* 0082 */ IPROP_TLIST_COPYITEM,
  /* 0083 */ IPROP_TLIST_COPYITEMSUB,
  /* 0084 */ IPROP_TLIST_COPYSELECTED,
  /* 0085 */ IPROP_TLIST_CLEARITEM,
  /* 0086 */ IPROP_TLIST_TABSTOP,
  /* 0087 */ IPROP_TLIST_PARENT,
  /* 0088 */ IPROP_TLIST_FIXEDSIZE,
  /* 0089 */ IPROP_TLIST_TABSTOPDISTANCE,
  /* 0090 */ IPROP_TLIST_90,
  /* 0091 */ IPROP_TLIST_ENVIRONMENT,
  /* 0092 */ IPROP_TLIST_DRAGEX,
  /* 0093 */ IPROP_TLIST_DRAGICONEX,
  /* 0094 */ IPROP_TLIST_SCROLLBARS,
  /* 0095 */ IPROP_TLIST_BOTTOMINDEX,
  /* 0096 */ IPROP_TLIST_SCROLLHORZ,
  /* 0097 */ IPROP_TLIST_ITEMEDITTEXT,
  /* 0098 */ IPROP_TLIST_LOADANDADD,
  /* 0099 */ IPROP_TLIST_LOADANDINSERT,
  /* 0100 */ IPROP_TLIST_SAVE,
  /* 0101 */ IPROP_TLIST_SAVESUB,
  /* 0102 */ IPROP_TLIST_ITEMPICVALUE,
  /* 0103 */ IPROP_TLIST_TEXT,
  /* 0104 */ IPROP_TLIST_CLIPBOARD,
  /* 0105 */ IPROP_TLIST_ISCLIPBOARDAVAILABLE,
  /* 0106 */ IPROP_TLIST_PICTUREPLUS,
  /* 0107 */ IPROP_TLIST_PICTUREMINUS,
  /* 0108 */ IPROP_TLIST_PICTUREMARK,
  /* 0109 */ IPROP_TLIST_AUTOSCRDURINGDRAGDROP,
  /* 0110 */ IPROP_TLIST_NOPICTUREROOT,
  /* 0111 */ IPROP_TLIST_VIEWSTYLEEX,
  /* 0112 */ IPROP_TLIST_ITEMMARK,
  /* 0113 */ IPROP_TLIST_MARKPICTURE,
  /* 0114 */ IPROP_TLIST_MARKTAG,
  /* 0115 */ IPROP_TLIST_MARKHEIGHT,
  /* 0116 */ IPROP_TLIST_MARKWIDTH,
  /* 0117 */ IPROP_TLIST_AUTOEXPAND,
  /* 0118 */ IPROP_TLIST_118,
  /* 0119 */ IPROP_TLIST_TREELINESSTYLE,
  /* 0120 */ IPROP_TLIST_PICINMULTILINE,
  /* 0121 */ IPROP_TLIST_SHOWCAPTION,
  /* 0122 */ IPROP_TLIST_CAPTION,
  /* 0123 */ IPROP_TLIST_SHOWTITLES,
  /* 0124 */ IPROP_TLIST_TITLEPICTURE,
  /* 0125 */ IPROP_TLIST_TITLETEXT,
  /* 0126 */ IPROP_TLIST_TITLEVISIBLE,
  /* 0127 */ IPROP_TLIST_TITLEWIDTH,
  /* 0128 */ IPROP_TLIST_TITLEHEIGHT,
  /* 0129 */ IPROP_TLIST_XOFFSET,
  /* 0130 */ IPROP_TLIST_INDENT,
  /* 0131 */ IPROP_TLIST_MSOUTLINEADD,
  /* 0132 */ IPROP_TLIST_LISTCOUNTEX,
  /* 0133 */ IPROP_TLIST_SELECTEX,
  /* 0134 */ IPROP_TLIST_EXPANDEX,
  /* 0135 */ IPROP_TLIST_SELITEMCOUNT,
  /* 0136 */ IPROP_TLIST_SELITEMINDEX,
  /* 0137 */ IPROP_TLIST_ITEMBM,
  /* 0138 */ IPROP_TLIST_CURRENTITEMBM,
  /* 0139 */ IPROP_TLIST_NEWINDEX,
  /* 0140 */ IPROP_TLIST_BACKWARDCOMPATIBILITY,
  /* 0141 */ IPROP_TLIST_FILE,
  /* 0142 */ IPROP_TLIST_EXPANDCHILDREN,
  /* 0143 */ IPROP_TLIST_EXPANDNEWITEM,
  /* 0144 */ IPROP_TLIST_COPYONE,
  /* 0145 */ IPROP_TLIST_SAVEONE,
  /* 0146 */ IPROP_TLIST_DRAGMODEEX,
  /* 0147 */ IPROP_TLIST_147,
  /* 0148 */ IPROP_TLIST_148,
  /* 0149 */ IPROP_TLIST_149,
  /* 0150 */ IPROP_TLIST_ITEMSORTED,
  /* 0151 */ IPROP_TLIST_ITEMPARENTBM,
  /* 0152 */ IPROP_TLIST_DEFMULTILINE,
  /* 0153 */ IPROP_TLIST_ITEMPMPICTYPE,
  /* 0154 */ IPROP_TLIST_WIDTHOFTEXTMIN,
  /* 0155 */ IPROP_TLIST_SMARTDRAGDROP
};

//
// Events' constants
//
enum
{
  /* 0000 */ IEVENT_TLIST_EXPAND,
  /* 0001 */ IEVENT_TLIST_COLLAPSE,
  /* 0002 */ IEVENT_TLIST_PICTURECLICK,
  /* 0003 */ IEVENT_TLIST_PICTUREDBLCLICK,
  /* 0004 */ IEVENT_TLIST_CLICK,
  /* 0005 */ IEVENT_TLIST_DBLCLICK,
  /* 0006 */ IEVENT_TLIST_KEYDOWN,
  /* 0007 */ IEVENT_TLIST_KEYUP,
  /* 0008 */ IEVENT_TLIST_KEYPRESS,
  /* 0009 */ IEVENT_TLIST_GOTFOCUS,
  /* 0010 */ IEVENT_TLIST_LOSTFOCUS,
  /* 0011 */ IEVENT_TLIST_MOUSEDOWN,
  /* 0012 */ IEVENT_TLIST_MOUSEMOVE,
  /* 0013 */ IEVENT_TLIST_MOUSEUP,
  /* 0014 */ IEVENT_TLIST_DRAGDROP,
  /* 0015 */ IEVENT_TLIST_DRAGOVER,

  /* 0016 */ IEVENT_TLIST_DRAGDROPEX,
  /* 0017 */ IEVENT_TLIST_DRAGOVEREX,
  /* 0018 */ IEVENT_TLIST_HSCROLL,
  /* 0019 */ IEVENT_TLIST_VSCROLL,
  /* 0020 */ IEVENT_TLIST_PLUSMINUSCLICK,
  /* 0021 */ IEVENT_TLIST_PLUSMINUSDBLCLICK,

  /* 0022 */ IEVENT_TLIST_MARKCLICK,
  /* 0023 */ IEVENT_TLIST_MARKDBLCLICK,
  /* 0024 */ IEVENT_TLIST_REQUESTEDITING,
  /* 0025 */ IEVENT_TLIST_AFTEREDITING,
  /* 0026 */ IEVENT_TLIST_EDITINGKEYDOWN,
  /* 0027 */ IEVENT_TLIST_EDITINGKEYUP,
  /* 0028 */ IEVENT_TLIST_EDITINGKEYPRESS
};

// System & CoerceIndex properties constants
enum
{
  TLSYS_ENUM,
  TLSYS_VIS,
  TLSYS_LEVEL
};


// PictureType property constants
enum
{
  TLPICTYPE_SOLVED,
  TLPICTYPE_ROOT,
  TLPICTYPE_OPEN,
  TLPICTYPE_CLOSED,
  TLPICTYPE_LEAF
};

// InvStyle property constants
enum
{
  TLINVS_TEXTPIC,
  TLINVS_PIC,
  TLINVS_TEXT,
  TLINVS_ALL,
  TLINVS_TEXTPICEX,
  TLINVS_TEXTBACK
};

// ViewStyle property constants
enum
{
  TLVIEWS_PICTEXTLINKS,
  TLVIEWS_PICTEXT,
  TLVIEWS_PICLINKS,
  TLVIEWS_PIC,
  TLVIEWS_TEXTLINKS,
  TLVIEWS_TEXT
};

// MultiSelect property constants
enum
{
  TLMULSEL_NONE,
  TLMULSEL_SIMPLE,
  TLMULSEL_EXT
};

// ExplorerCompatible property constants
enum
{
  TLEXPLOR_NONE,
  TLEXPLOR_KEYSTROKES,
  TLEXPLOR_APPEARANCE,
  TLEXPLOR_KEYSTROKES_APPEARANCE
};

// ToolTipsMode property constants
enum
{
  TLTTIPSMODE_DISABLE,
  TLTTIPSMODE_ENABLE
};

// ToolTipsViewStyle property constants
enum
{
  TLTTIPSSTYLE_PREDEFINED,
  TLTTIPSSTYLE_USERDEFINED
};

// ItemType property constants
#define TLTYPE_NONE       0x0000
#define TLTYPE_INT        0x494E
#define TLTYPE_LNG        0x4C4E
#define TLTYPE_SNG        0x534E
#define TLTYPE_STR        0x5354
#define TLTYPE_PIC        0x5450

// Error codes constants
#define TLERR_BADINDENTATION     20101
#define TLERR_WRONPARAMS         20102
#define TLERR_ITEMNOTFOUND       20103
#define TLERR_PARENTNOTEXPANDED  20104
#define TLERR_INITFAULT          20105
#define TLERR_CANNOTSHOW         20106
#define TLERR_INVALIDSEPARATOR   20107
#define TLERR_INVALIDTREEBUFFER  20108
#define TLERR_BIGPICSIZE         20109
#define TLERR_NOTHINGTOCOPY      20110
#define TLERR_TOMANYITEMS        20111
#define TLERR_TOMANYSUBITEMS     20112
#define TLERR_INVALIDARGS        20113

// TriggerEvents property constants
enum
{
  TL_TRIGGER_INITIAL,
  TL_TRIGGER_COLLAPSE_FOR_ALL
};

// VScroll & HScroll ScrollCode parameter constants
enum
{
  TL_SB_LINEUP,
  TL_SB_LINEDOWN,
  TL_SB_PAGEUP,
  TL_SB_PAGEDOWN,
  TL_SB_THUMBPOSITION,
  TL_SB_THUMBTRACK,
  TL_SB_TOP,
  TL_SB_BOTTOM,
  TL_SB_ENDSCROLL
};

//defines for extract information from event parameters
#define AFX_NUM_EVENTPARAM(type, lpParams) \
  (type FAR&)(**(type FAR* FAR*)lpParams)
#define AFX_HLSTR_EVENTPARAM(lpParams) \
  (HLSTR FAR&)(*(HLSTR FAR*)lpParams)
#define AFX_NUM_EVENTPARAMINDEX(type, lpParams, index) \
  (short FAR&)(**((type FAR* FAR*)(lpParams) + index))
#define AFX_HLSTR_EVENTPARAMINDEX(lpParams, index) \
  (HLSTR FAR&)(*((HLSTR FAR*)(lpParams) + index))


DECLARE_HANDLE32(HTREEBUFFER);
class CTList;

// TList's functions declarations
extern "C"
VOID WINAPI TListFreeBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int  WINAPI TListIsValidBuffer(HTREEBUFFER hTreeBuffer);

// new functions for TList Pro version
extern "C"
int WINAPI TListTranslateIndex(CTList* TListTree, int nFromIndexMethod,
                               int nToIndexMethod, int nFromIndex);
extern "C"
int WINAPI TListGetItemByXY(CTList* TListTree, int nX, int nY, int nType);

extern "C"
int WINAPI TListGetItemRect(CTList* TListTree, int nIndex, int nOpts,
                            LPRECT lpRectT);

extern "C"
int WINAPI TListSaveBuffer(HTREEBUFFER hTreeBuffer, int nFile);

extern "C"
int WINAPI TListLoadBuffer(HTREEBUFFER hTreeBuffer, int nFile);

extern "C"
int WINAPI TListCopyBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int WINAPI TListPasteBuffer(HTREEBUFFER hTreeBuffer);

extern "C"
int WINAPI TListIsClipboardFormatAvailable();

extern "C"
int WINAPI TListIndexByBM(CTList* TListTree, LONG hTreeBookmark);

extern "C"
int WINAPI TListIsValidBM(CTList* TListTree, LONG hTreeBookmark);

extern "C"
int WINAPI TListFindItem(CTList* TListTree, LPSTR lpFindWhat,
                         int nFlags, int nFromIndex, int nToIndex);

extern "C"
int WINAPI TListFindValue(CTList* TListTree, LPVOID lpFindWhat, int nFlags,
                          int nFromIndex, int nToIndex);


#define TLM_DRAGOVEREX_STR "TLM_DRAGOVEREX"
#define TLM_DRAGDROPEX_STR "TLM_DRAGDROPEX"

// MFC supplementary class

class CTList : public CVBControl
{
  DECLARE_DYNAMIC(CTList)

  public:
    enum DragMode
    {
      dragCancel    = 0,
      dragBegin     = 1,
      dragEnd       = 2
    };

  public:
    // functions
    static  void              FreeBuffer     (HTREEBUFFER hTreeBuffer);
    static  int               IsValidBuffer  (HTREEBUFFER hTreeBuffer);
            int               TranslateIndex (int nFromIndexMethod,
                                              int nToIndexMethod,
                                              int nFromIndex);
            int               GetItemByXY    (int nX, int nY, int nType);
            int               GetItemRect    (int nIndex, int nOpts,
                                              LPRECT lpRectT);
    static  int               SaveBuffer     (HTREEBUFFER hTreeBuffer,
                                              int nFile);
    static  int               LoadBuffer     (HTREEBUFFER hTreeBuffer,
                                              int nFile);
    static  int               CopyBuffer     (HTREEBUFFER hTreeBuffer);
    static  int               PasteBuffer    (HTREEBUFFER hTreeBuffer);
    static  int               IsClipboardFormatAvailable
                                             ();
            int               IndexByBM      (LONG hTreeBookmark);
            int               IsValidBM      (LONG hTreeBookmark);
            int               FindItem       (LPSTR lpFindWhat, int nFlags,
                                              int nFromIndex, int nToIndex);

    // properties
    inline  CString           Tag            ();
    inline  BOOL              Tag            (CString &);
    inline  BOOL              ImageStretch   ();
    inline  BOOL              ImageStretch   (BOOL);
    inline  int               InvStyle       ();
    inline  BOOL              InvStyle       (BOOL);
    inline  int               ViewStyle      ();
    inline  BOOL              ViewStyle      (BOOL);
    inline  int               ShiftStep      ();
    inline  BOOL              ShiftStep      (int);
    inline  int               ImageDefHeight ();
    inline  BOOL              ImageDefHeight (int);
    inline  int               ImageDefWidth  ();
    inline  BOOL              ImageDefWidth  (int);
    inline  int               ListCount      ();
    inline  int               ListIndex      ();
    inline  BOOL              ListIndex      (int nIndex);
    inline  BOOL              Redraw         ();
    inline  BOOL              Redraw         (BOOL);
    inline  int               MultiSelect    ();
    inline  int               Selected       (int nIndex);
    inline  BOOL              Selected       (int nIndex, BOOL bSel);
    inline  CString           List           (int nIndex);
    inline  BOOL              List           (int nIndex, CString &);
    inline  HPIC              Image          (int nIndex);
    inline  BOOL              Image          (int nIndex, HPIC);
    inline  HPIC              InvImage       (int nIndex);
    inline  BOOL              InvImage       (int nIndex, HPIC);
    inline  COLORREF          ItemBackColor  (int nIndex);
    inline  BOOL              ItemBackColor  (int nIndex, COLORREF);
    inline  COLORREF          ItemForeColor  (int nIndex);
    inline  BOOL              ItemForeColor  (int nIndex, COLORREF);
    inline  CString           ItemFontName   ();
    inline  BOOL              ItemFontName   (CString &);
    inline  BOOL              ItemFontBold   (int nIndex);
    inline  BOOL              ItemFontBold   (int nIndex, BOOL bBold);
    inline  BOOL              ItemFontItalic (int nIndex);
    inline  BOOL              ItemFontItalic (int nIndex, BOOL bItalic);
    inline  BOOL              ItemFontStrike (int nIndex);
    inline  BOOL              ItemFontStrike (int nIndex, BOOL bStrike);
    inline  BOOL              ItemFontUnder  (int nIndex);
    inline  BOOL              ItemFontUnder  (int nIndex, BOOL bUnder);
    inline  int               Shift          (int nIndex);
    inline  BOOL              Shift          (int nIndex, int nShift);
    inline  CString           FullPath       (int nIndex);
    inline  int               PictureType    ();
    inline  BOOL              PictureType    (int nType);
    inline  BOOL              Expand         (int nIndex);
    inline  BOOL              Expand         (int nIndex, BOOL bExpand);
    inline  CString           PathSeparator  ();
    inline  BOOL              PathSeparator  (CString &);
    inline  int               TopIndex       ();
    inline  BOOL              TopIndex       (int nIndex);
    inline  BOOL              HasSubItems    (int nIndex);
    inline  BOOL              IsItemVisible  (int nIndex);
    inline  HPIC              PictureRoot    ();
    inline  BOOL              PictureRoot    (HPIC);
    inline  HPIC              PictureOpen    ();
    inline  BOOL              PictureOpen    (HPIC);
    inline  HPIC              PictureClosed  ();
    inline  BOOL              PictureClosed  (HPIC);
    inline  HPIC              PictureLeaf    ();
    inline  BOOL              PictureLeaf    (HPIC);
    inline  HPIC              PictureInverted();
    inline  BOOL              PictureInverted(HPIC);
    inline  int               CurIndexMethod ();
    inline  BOOL              CurIndexMethod (int nIndexMethod);
    inline  COLORREF          SelForeColor   ();
    inline  BOOL              SelForeColor   (COLORREF);
    inline  COLORREF          SelBackColor   ();
    inline  BOOL              SelBackColor   (COLORREF);
    inline  BOOL              InsertItem     (int nIndex, CString &);
    inline  BOOL              NoIntegralHeight();
    inline  BOOL              DisableNoScroll();
    inline  int               WidthOfText    ();
    inline  BOOL              WidthOfText    (int cxWidth);
    inline  BOOL              ItemMultiLine  (int nIndex);
    inline  BOOL              ItemMultiLine  (int nIndex, BOOL bMulti);
    inline  CString           CurrentItem    ();
    inline  BOOL              CurrentItem    (CString &);
    inline  int               DragHighLight  ();
    inline  BOOL              DragHighLight  (int);
    inline  BOOL              ShowChildren   ();
    inline  BOOL              ShowChildren   (BOOL bShowChildren);
    inline  int               CoerceIndex    (int EnumSystem);
    inline  BOOL              CoerceIndex    (int nIndex, int EnumSystem);
    inline  int               DropTarget     ();
    inline  int               ItemType       (int nIndex);
    inline  BOOL              ItemType       (int nIndex, int nType);
    inline  int               ItemIntValue   (int nIndex);
    inline  BOOL              ItemIntValue   (int nIndex, int nValue);
    inline  LONG              ItemLngValue   (int nIndex);
    inline  BOOL              ItemLngValue   (int nIndex, LONG lValue);
    inline  float             ItemSngValue   (int nIndex);
    inline  BOOL              ItemSngValue   (int nIndex, float);
    inline  CString           ItemStrValue   (int nIndex);
    inline  BOOL              ItemStrValue   (int nIndex, CString &);
    inline  BOOL              Add            (int nIndex, HTREEBUFFER);
    inline  BOOL              Insert         (int nIndex, HTREEBUFFER);
    inline  HTREEBUFFER       CopyItem       (int nIndex);
    inline  HTREEBUFFER       CopyItemSub    (int nIndex);
    inline  HTREEBUFFER       CopySelected   ();
    inline  BOOL              ClearItem      (int nIndex);
    inline  BOOL              FixedSize      ();
    inline  int               TabStopDistance();
    inline  BOOL              TabStopDistance(int nTabStopIndex);
    inline  BOOL              DragEx         (DragMode);
    inline  HPIC              DragIconEx     ();
    inline  BOOL              DragIconEx     (HPIC);
    inline  int               ScrollBars     ();
    inline  int               BottomIndex    ();
    inline  int               ScrollHorz     ();
    inline  BOOL              ScrollHorz     (int);
    inline  BOOL              ItemEditText   (int);
    inline  BOOL              LoadAndAdd     (int nIndex, int FileHandle);
    inline  BOOL              LoadAndInsert  (int nIndex, int FileHandle);
    inline  BOOL              Save           (int nIndex, int FileHandle);
    inline  BOOL              SaveSub        (int nIndex, int FileHandle);
    inline  HPIC              ItemPicValue   ();
    inline  BOOL              ItemPicValue   (HPIC);
    inline  CString           Text           (int nIndex);
    inline  BOOL              Text           (int nIndex, CString &);
    inline  BOOL              Clipboard      (int nIndex, int);
    inline  BOOL              IsClipboardAviable
                                             (int nIndex);
    inline  HPIC              PicturePlus    ();
    inline  BOOL              PicturePlus    (HPIC);
    inline  HPIC              PictureMinus   ();
    inline  BOOL              PictureMinus   (HPIC);
    inline  HPIC              PictureMark    ();
    inline  BOOL              PictureMark    (HPIC);
    inline  BOOL              AutoScrDuringDragDrop
                                             ();
    inline  BOOL              AutoScrDuringDragDrop
                                             (int);
    inline  BOOL              NoPictureRoot  (BOOL);
    inline  BOOL              NoPictureRoot  ();
    inline  BOOL              ViewStyleEx    (int);
    inline  int               ViewStyleEx    ();
    inline  BOOL              ItemMark       (int nIndex, int MarkIndex);
    inline  int               ItemMark       (int nIndex);
    inline  BOOL              MarkPicture    (int nIndex, HPIC);
    inline  HPIC              MarkPicture    (int nIndex);
    inline  BOOL              MarkTag        (int nIndex, CString &);
    inline  CString           MarkTag        (int nIndex);
    inline  BOOL              MarkHeight     (int nIndex, LONG);
    inline  LONG              MarkHeight     (int nIndex);
    inline  BOOL              MarkWidth      (int nIndex, LONG);
    inline  LONG              MarkWidth      (int nIndex);
    inline  BOOL              AutoExpand     (int);
    inline  int               AutoExpand     ();
    inline  BOOL              TreeLinesStyle (int);
    inline  int               TreeLinesStyle ();
    inline  BOOL              PicInMultiLine (int);
    inline  int               PicInMultiLine ();
    inline  BOOL              ShowCaption    (int);
    inline  int               ShowCaption    ();
    inline  BOOL              Caption        (CString &);
    inline  CString           Caption        ();
    inline  BOOL              ShowTitles     (int);
    inline  int               ShowTitles     ();
    inline  BOOL              TitlePicture   (int nIndex, HPIC);
    inline  HPIC              TitlePicture   (int nIndex);
    inline  BOOL              TitleText      (int nIndex, CString &);
    inline  CString           TitleText      (int nIndex);
    inline  BOOL              TitleVisible   (int);
    inline  int               TitleVisible   ();
    inline  BOOL              TitleWidth     (int nIndex, LONG);
    inline  LONG              TitleWidth     (int nIndex);
    inline  BOOL              TitleHeight    (int nIndex, LONG);
    inline  LONG              TitleHeight    (int nIndex);
    inline  BOOL              XOffset        (LONG);
    inline  LONG              XOffset        ();
    inline  BOOL              Indent         (int nIndex, int);
    inline  int               Indent         (int nIndex);
    inline  BOOL              MSOutlineAdd   (BOOL);
    inline  BOOL              MSOutlineAdd   ();
    inline  int               ListCountEx    (int nIndex);
    inline  BOOL              SelectEx       (int nIndex, BOOL);
    inline  BOOL              ExpandEx       (int nIndex, BOOL);
    inline  int               SelItemCount   ();
    inline  int               SelItemIndex   (int nIndex);
    inline  LONG              ItemBM         (int nIndex);
    inline  BOOL              CurrentItemBM  (int nIndex, LONG);
    inline  LONG              CurrentItemBM  (int nIndex);
    inline  int               NewIndex       ();
    inline  BOOL              BackwardCompatibility
                                             (BOOL);
    inline  BOOL              BackwardCompatibility
                                             ();
    inline  BOOL              File           (int FileHandle, int Mode);
    inline  BOOL              ExpandChildren (BOOL);
    inline  BOOL              ExpandChildren ();
    inline  BOOL              ExpandNewItem  (int, BOOL);
    inline  BOOL              ExpandNewItem  (int);
    inline  LONG              CopyOne        (int nIndex);
    inline  BOOL              SaveOne        (int nIndex, int FileHandle);
    inline  BOOL              DragModeEx     (int Mode);
    inline  int               DragModeEx     ();
    inline  BOOL              ItemSorted     (int nIndex, int SortMode);
    inline  int               ItemSorted     (int nIndex);
    inline  LONG              ItemParentBM   (int nIndex);
    inline  BOOL              DefMultiLine   (int nIndex, BOOL TextMode);
    inline  BOOL              DefMultiLine   (int nIndex);
    inline  BOOL              ItemPMPicType  (int nIndex, int PicType);
    inline  int               ItemPMPicType  (int nIndex);
    inline  BOOL              WidthOfTextMin (float NewSize);
    inline  float             WidthOfTextMin ();
    inline  BOOL              SmartDragDrop  (BOOL Mode);
    inline  BOOL              SmartDragDrop  ();

  protected:
#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

  // Generated message map functions
protected:
  //{{AFX_MSG(CTList)
    // NOTE - the ClassWizard will add and remove member functions here.
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

// pseudo-inline functions
// DDX control aliasing - stores a pointer to true C++ object
inline void AFXAPI DDX_VBControl
(
  CDataExchange* pDX, int nIDC, CTList*& rpControl
)
{
  DDX_VBControl(pDX, nIDC, (CVBControl*&)rpControl);
}

// pseudo-inline functions
inline CString CTList::Tag()
{ return GetStrProperty(IPROP_TLIST_TAG);}

inline BOOL CTList::Tag(CString & str)
{ return SetStrProperty(IPROP_TLIST_TAG, str);}

inline BOOL CTList::ImageStretch()
{ return BOOL(GetNumProperty(IPROP_TLIST_IMAGESTRETCH));}

inline BOOL CTList::ImageStretch(BOOL bImageStretch)
{ return SetNumProperty(IPROP_TLIST_IMAGESTRETCH, bImageStretch);}

inline int CTList::InvStyle()
{ return int(GetNumProperty(IPROP_TLIST_INVSTYLE));}

inline BOOL CTList::InvStyle(BOOL bInvStyle)
{ return SetNumProperty(IPROP_TLIST_INVSTYLE, bInvStyle);}

inline int CTList::ViewStyle()
{ return int(GetNumProperty(IPROP_TLIST_VIEWSTYLE));}

inline BOOL CTList::ViewStyle(BOOL bViewStyle)
{ return SetNumProperty(IPROP_TLIST_VIEWSTYLE, bViewStyle);}

inline int CTList::ShiftStep()
{ return int(GetNumProperty(IPROP_TLIST_SHIFTSTEP));}

inline BOOL CTList::ShiftStep(int nShiftStep)
{ return SetNumProperty(IPROP_TLIST_SHIFTSTEP, nShiftStep);}

inline int CTList::ImageDefHeight()
{ return int(GetNumProperty(IPROP_TLIST_IMAGEDEFHEIGHT));}

inline BOOL CTList::ImageDefHeight(int cy)
{ return SetNumProperty(IPROP_TLIST_IMAGEDEFHEIGHT, cy);}

inline int CTList::ImageDefWidth()
{ return int(GetNumProperty(IPROP_TLIST_IMAGEDEFWIDTH));}

inline BOOL CTList::ImageDefWidth(int cx)
{ return SetNumProperty(IPROP_TLIST_IMAGEDEFWIDTH, cx);}

inline int CTList::ListCount()
{ return int(GetNumProperty(IPROP_TLIST_LISTCOUNT));}

inline int CTList::ListIndex()
{ return int(GetNumProperty(IPROP_TLIST_LISTINDEX));}

inline BOOL CTList::ListIndex(int nIndex)
{ return SetNumProperty(IPROP_TLIST_LISTINDEX, nIndex);}

inline BOOL CTList::Redraw()
{ return BOOL(GetNumProperty(IPROP_TLIST_REDRAW));}

inline BOOL CTList::Redraw(BOOL bRedraw)
{ return SetNumProperty(IPROP_TLIST_REDRAW, bRedraw);}

inline int CTList::MultiSelect()
{ return int(GetNumProperty(IPROP_TLIST_MULTISELECT));}

inline int CTList::Selected(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_SELECTED, nIndex));}

inline BOOL CTList::Selected(int nIndex, BOOL bSel)
{ return SetNumProperty(IPROP_TLIST_SELECTED, bSel, nIndex);}

inline CString CTList::List(int nIndex)
{ return GetStrProperty(IPROP_TLIST_LIST, nIndex);}

inline BOOL CTList::List(int nIndex, CString & str)
{ return SetStrProperty(IPROP_TLIST_LIST, str, nIndex);}

inline HPIC CTList::Image(int nIndex)
{ return GetPictureProperty(IPROP_TLIST_IMAGE, nIndex);}

inline BOOL CTList::Image(int nIndex, HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_IMAGE, hpic, nIndex);}

inline HPIC CTList::InvImage(int nIndex)
{ return GetPictureProperty(IPROP_TLIST_INVIMAGE, nIndex);}

inline BOOL CTList::InvImage(int nIndex, HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_INVIMAGE, hpic, nIndex);}

inline COLORREF CTList::ItemBackColor(int nIndex)
{ return COLORREF(GetNumProperty(IPROP_TLIST_ITEMBACKCOLOR, nIndex));}

inline BOOL CTList::ItemBackColor(int nIndex, COLORREF clrref)
{ return SetNumProperty(IPROP_TLIST_ITEMBACKCOLOR, clrref, nIndex);}

inline COLORREF CTList::ItemForeColor(int nIndex)
{ return COLORREF(GetNumProperty(IPROP_TLIST_ITEMFORECOLOR, nIndex));}

inline BOOL CTList::ItemForeColor(int nIndex, COLORREF clrref)
{ return SetNumProperty(IPROP_TLIST_ITEMFORECOLOR, clrref, nIndex);}

inline CString CTList::ItemFontName()
{ return GetStrProperty(IPROP_TLIST_ITEMFONTNAME);}

inline  BOOL CTList::ItemFontName(CString &FontName)
{ return SetStrProperty(IPROP_TLIST_ITEMFONTNAME, FontName);}

inline  BOOL CTList::ItemFontBold(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMFONTBOLD, nIndex));}

inline  BOOL CTList::ItemFontBold(int nIndex, BOOL bBold)
{ return SetNumProperty(IPROP_TLIST_ITEMFONTBOLD, bBold, nIndex);}

inline  BOOL CTList::ItemFontItalic(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMFONTITALIC, nIndex));}

inline  BOOL CTList::ItemFontItalic(int nIndex, BOOL bItalic)
{ return SetNumProperty(IPROP_TLIST_ITEMFONTITALIC, bItalic, nIndex);}

inline  BOOL CTList::ItemFontStrike(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMFONTSTRIKE, nIndex));}

inline  BOOL CTList::ItemFontStrike(int nIndex, BOOL bStrike)
{ return SetNumProperty(IPROP_TLIST_ITEMFONTSTRIKE, bStrike, nIndex);}

inline  BOOL CTList::ItemFontUnder(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMFONTUNDER, nIndex));}

inline  BOOL CTList::ItemFontUnder(int nIndex, BOOL bUnder)
{ return SetNumProperty(IPROP_TLIST_ITEMFONTUNDER, bUnder, nIndex);}

inline int CTList::Shift(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_SHIFT, nIndex));}

inline BOOL CTList::Shift(int nIndex, int nShift)
{ return SetNumProperty(IPROP_TLIST_SHIFT, nShift, nIndex);}

inline CString CTList::FullPath(int nIndex)
{ return GetStrProperty(IPROP_TLIST_FULLPATH, nIndex);}

inline int CTList::PictureType()
{ return int(GetNumProperty(IPROP_TLIST_PICTURETYPE));}

inline BOOL CTList::PictureType(int nType)
{ return SetNumProperty(IPROP_TLIST_PICTURETYPE, nType);}

inline BOOL CTList::Expand(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_EXPAND, nIndex));}

inline BOOL CTList::Expand(BOOL bExpand, int nIndex)
{ return SetNumProperty(IPROP_TLIST_EXPAND, bExpand, nIndex);}

inline CString CTList::PathSeparator()
{ return GetStrProperty(IPROP_TLIST_PATHSEPARATOR);}

inline BOOL CTList::PathSeparator(CString & str)
{ return SetStrProperty(IPROP_TLIST_PATHSEPARATOR, str);}

inline int CTList::TopIndex()
{ return int(GetNumProperty(IPROP_TLIST_TOPINDEX));}

inline BOOL CTList::TopIndex(int nTopIndex)
{ return SetNumProperty(IPROP_TLIST_TOPINDEX, nTopIndex);}

inline BOOL CTList::HasSubItems(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_HASSUBITEMS, nIndex));}

inline BOOL CTList::IsItemVisible(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ISITEMVISIBLE, nIndex));}

inline HPIC CTList::PictureRoot()
{ return GetPictureProperty(IPROP_TLIST_PICTUREROOT);}

inline BOOL CTList::PictureRoot(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREROOT, hpic);}

inline HPIC CTList::PictureOpen()
{ return GetPictureProperty(IPROP_TLIST_PICTUREOPEN);}

inline BOOL CTList::PictureOpen(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREOPEN, hpic);}

inline HPIC CTList::PictureClosed()
{ return GetPictureProperty(IPROP_TLIST_PICTURECLOSED);}

inline BOOL CTList::PictureClosed(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTURECLOSED, hpic);}

inline HPIC CTList::PictureLeaf()
{ return GetPictureProperty(IPROP_TLIST_PICTURELEAF);}

inline BOOL CTList::PictureLeaf(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTURELEAF, hpic);}

inline HPIC CTList::PictureInverted()
{ return GetPictureProperty(IPROP_TLIST_PICTUREINVERTED);}

inline BOOL CTList::PictureInverted(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREINVERTED, hpic);}

inline int CTList::CurIndexMethod()
{ return int(GetNumProperty(IPROP_TLIST_CURINDEXMETHOD));}

inline BOOL CTList::CurIndexMethod(int nIndexMethod)
{ return SetNumProperty(IPROP_TLIST_CURINDEXMETHOD, nIndexMethod);}

inline COLORREF CTList::SelForeColor()
{ return COLORREF(GetNumProperty(IPROP_TLIST_SELFORECOLOR));}

inline BOOL CTList::SelForeColor(COLORREF clrref)
{ return SetNumProperty(IPROP_TLIST_SELFORECOLOR, clrref);}

inline COLORREF CTList::SelBackColor()
{ return COLORREF(GetNumProperty(IPROP_TLIST_SELBACKCOLOR));}

inline BOOL CTList::SelBackColor(COLORREF clrref)
{ return SetNumProperty(IPROP_TLIST_SELBACKCOLOR, clrref);}

inline BOOL CTList::InsertItem(int nIndex, CString & str)
{ return SetStrProperty(IPROP_TLIST_INSERTITEM, str, nIndex);}

inline BOOL CTList::NoIntegralHeight()
{ return BOOL(GetNumProperty(IPROP_TLIST_NOINTEGRALHEIGHT));}

inline BOOL CTList::DisableNoScroll()
{ return BOOL(GetNumProperty(IPROP_TLIST_DISABLENOSCROLL));}

inline int CTList::WidthOfText()
{ return int(GetNumProperty(IPROP_TLIST_WIDTHOFTEXT));}

inline BOOL CTList::WidthOfText(int cxWidth)
{ return SetNumProperty(IPROP_TLIST_WIDTHOFTEXT, cxWidth);}

inline BOOL CTList::ItemMultiLine(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMMULTILINE, nIndex));}

inline BOOL CTList::ItemMultiLine(int nIndex, BOOL bMultiLine)
{ return SetNumProperty(IPROP_TLIST_ITEMMULTILINE, bMultiLine, nIndex);}

inline CString CTList::CurrentItem()
{ return GetStrProperty(IPROP_TLIST_CURRENTITEM);}

inline BOOL CTList::CurrentItem(CString & str)
{ return SetStrProperty(IPROP_TLIST_CURRENTITEM, str);}

inline int CTList::DragHighLight  ()
{ return int(GetNumProperty(IPROP_TLIST_DRAGHIGHLIGHT));}

inline BOOL CTList::DragHighLight(int Mode)
{ return SetNumProperty(IPROP_TLIST_DRAGHIGHLIGHT, Mode);}

inline BOOL CTList::ShowChildren()
{ return BOOL(GetNumProperty(IPROP_TLIST_SHOWCHILDREN));}

inline BOOL CTList::ShowChildren(BOOL bShowChildren)
{ return SetNumProperty(IPROP_TLIST_SHOWCHILDREN, bShowChildren);}

inline  int CTList::CoerceIndex(int EnumSystem)
{ return int(GetNumProperty(IPROP_TLIST_COERCEINDEX, EnumSystem));}

inline  BOOL CTList::CoerceIndex(int nIndex, int EnumSystem)
{ return SetNumProperty(IPROP_TLIST_COERCEINDEX, EnumSystem, nIndex);}

inline int CTList::DropTarget()
{ return int(GetNumProperty(IPROP_TLIST_DROPTARGET)); }

inline int CTList::ItemType(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_ITEMTYPE, nIndex));}

inline BOOL CTList::ItemType(int nIndex, int nType)
{ return int(SetNumProperty(IPROP_TLIST_ITEMTYPE, nType, nIndex));}

inline int CTList::ItemIntValue(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_ITEMINTVALUE, nIndex));}

inline BOOL CTList::ItemIntValue(int nIndex, int nValue)
{ return SetNumProperty(IPROP_TLIST_ITEMINTVALUE, nValue, nIndex);}

inline LONG CTList::ItemLngValue(int nIndex)
{ return GetNumProperty(IPROP_TLIST_ITEMLNGVALUE, nIndex);}

inline BOOL CTList::ItemLngValue(int nIndex, LONG lValue)
{ return SetNumProperty(IPROP_TLIST_ITEMLNGVALUE, lValue, nIndex);}

inline float CTList::ItemSngValue(int nIndex)
{ return GetFloatProperty(IPROP_TLIST_ITEMSNGVALUE, nIndex);}

inline BOOL CTList::ItemSngValue(int nIndex, float fValue)
{ return SetFloatProperty(IPROP_TLIST_ITEMSNGVALUE, fValue, nIndex);}

inline CString CTList::ItemStrValue(int nIndex)
{ return GetStrProperty(IPROP_TLIST_ITEMSTRVALUE, nIndex);}

inline BOOL CTList::ItemStrValue(int nIndex, CString & str)
{ return SetStrProperty(IPROP_TLIST_ITEMSTRVALUE, str, nIndex);}

inline BOOL CTList::Add(int nIndex, HTREEBUFFER htr)
{ return SetNumProperty(IPROP_TLIST_ADD, LONG(htr), nIndex);}

inline BOOL CTList::Insert(int nIndex, HTREEBUFFER htr)
{ return SetNumProperty(IPROP_TLIST_INSERT, LONG(htr), nIndex);}

inline HTREEBUFFER CTList::CopyItem(int nIndex)
{ return HTREEBUFFER(GetNumProperty(IPROP_TLIST_COPYITEM, nIndex));}

inline HTREEBUFFER CTList::CopyItemSub(int nIndex)
{ return HTREEBUFFER(GetNumProperty(IPROP_TLIST_COPYITEMSUB, nIndex));}

inline HTREEBUFFER CTList::CopySelected()
{ return HTREEBUFFER(GetNumProperty(IPROP_TLIST_COPYSELECTED));}

inline BOOL CTList::ClearItem(int nIndex)
{ return SetNumProperty(IPROP_TLIST_CLEARITEM, nIndex);}

inline BOOL CTList::FixedSize()
{ return BOOL(GetNumProperty(IPROP_TLIST_FIXEDSIZE));}

inline int CTList::TabStopDistance()
{ return int(GetNumProperty(IPROP_TLIST_TABSTOPDISTANCE));}

inline BOOL CTList::TabStopDistance(int nTabStopDistance)
{ return int(SetNumProperty(IPROP_TLIST_TABSTOPDISTANCE, nTabStopDistance));}

//>...properties for TList Pro version (added 12.09.95)
inline BOOL CTList::DragEx(DragMode dragMode)
{ return int(SetNumProperty(IPROP_TLIST_DRAGEX, dragMode)); }

inline  HPIC CTList::DragIconEx()
{ return GetPictureProperty(IPROP_TLIST_DRAGICONEX);}

inline  BOOL CTList::DragIconEx(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_DRAGICONEX, hpic);}

inline  int CTList::ScrollBars()
{ return int(GetNumProperty(IPROP_TLIST_SCROLLBARS));}

inline  int CTList::BottomIndex()
{ return int(GetNumProperty(IPROP_TLIST_BOTTOMINDEX));}

inline  int CTList::ScrollHorz()
{ return int(GetNumProperty(IPROP_TLIST_SCROLLHORZ));}

inline  BOOL CTList::ScrollHorz(int Pos)
{ return SetNumProperty(IPROP_TLIST_SCROLLHORZ, Pos);}

inline  BOOL CTList::ItemEditText(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ITEMEDITTEXT, nIndex));}

inline  BOOL CTList::LoadAndAdd(int nIndex, int FileHandle)
{ return SetNumProperty(IPROP_TLIST_LOADANDADD, FileHandle, nIndex);}

inline  BOOL CTList::LoadAndInsert(int nIndex, int FileHandle)
{ return SetNumProperty(IPROP_TLIST_LOADANDINSERT, FileHandle, nIndex);}

inline  BOOL CTList::Save(int nIndex, int FileHandle)
{ return SetNumProperty(IPROP_TLIST_SAVE, FileHandle, nIndex);}

inline  BOOL CTList::SaveSub(int nIndex, int FileHandle)
{ return SetNumProperty(IPROP_TLIST_SAVESUB, FileHandle, nIndex);}

inline  HPIC CTList::ItemPicValue()
{ return GetPictureProperty(IPROP_TLIST_ITEMPICVALUE);}

inline  BOOL CTList::ItemPicValue(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_ITEMPICVALUE, hpic);}

inline  CString CTList::Text(int nIndex)
{ return GetStrProperty(IPROP_TLIST_TEXT, nIndex);}

inline  BOOL CTList::Text(int nIndex, CString &Text)
{ return SetStrProperty(IPROP_TLIST_TEXT, Text, nIndex);}

inline  BOOL CTList::Clipboard(int nIndex, int Mode)
{ return SetNumProperty(IPROP_TLIST_CLIPBOARD, Mode, nIndex);}

inline  BOOL CTList::IsClipboardAviable(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_ISCLIPBOARDAVAILABLE, nIndex));}

inline  HPIC CTList::PicturePlus()
{ return GetPictureProperty(IPROP_TLIST_PICTUREPLUS);}

inline  BOOL CTList::PicturePlus(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREPLUS, hpic);}

inline  HPIC CTList::PictureMinus()
{ return GetPictureProperty(IPROP_TLIST_PICTUREMINUS);}

inline  BOOL CTList::PictureMinus(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREMINUS, hpic);}

inline  HPIC CTList::PictureMark()
{ return GetPictureProperty(IPROP_TLIST_PICTUREMARK);}

inline  BOOL CTList::PictureMark(HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_PICTUREMARK, hpic);}

inline  BOOL CTList::AutoScrDuringDragDrop()
{ return BOOL(GetNumProperty(IPROP_TLIST_AUTOSCRDURINGDRAGDROP));}

inline  BOOL CTList::AutoScrDuringDragDrop(int Mode)
{ return SetNumProperty(IPROP_TLIST_AUTOSCRDURINGDRAGDROP, Mode);}

inline  BOOL CTList::NoPictureRoot()
{ return BOOL(GetNumProperty(IPROP_TLIST_NOPICTUREROOT));}

inline  BOOL CTList::NoPictureRoot(BOOL flag)
{ return SetNumProperty(IPROP_TLIST_NOPICTUREROOT, flag);}

inline  BOOL CTList::ViewStyleEx(int Style)
{ return SetNumProperty(IPROP_TLIST_VIEWSTYLEEX, Style);}

inline  int CTList::ViewStyleEx()
{ return BOOL(GetNumProperty(IPROP_TLIST_VIEWSTYLEEX));}

inline  BOOL CTList::ItemMark(int nIndex, int Mark)
{ return SetNumProperty(IPROP_TLIST_ITEMMARK, Mark, nIndex);}

inline  int CTList::ItemMark(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_ITEMMARK, nIndex));}

inline  BOOL CTList::MarkPicture(int nIndex, HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_MARKPICTURE, hpic);}

inline  HPIC CTList::MarkPicture(int nIndex)
{ return GetPictureProperty(IPROP_TLIST_MARKPICTURE);}

inline  BOOL CTList::MarkTag(int nIndex, CString &Tag)
{ return SetStrProperty(IPROP_TLIST_MARKTAG, Tag, nIndex);}

inline  CString CTList::MarkTag(int nIndex)
{ return GetStrProperty(IPROP_TLIST_MARKTAG, nIndex);}

inline  BOOL CTList::MarkHeight(int nIndex, LONG Height)
{ return SetNumProperty(IPROP_TLIST_MARKHEIGHT, Height, nIndex);}

inline  LONG CTList::MarkHeight(int nIndex)
{ return GetNumProperty(IPROP_TLIST_MARKHEIGHT, nIndex);}

inline  BOOL CTList::MarkWidth(int nIndex, LONG Width)
{ return SetNumProperty(IPROP_TLIST_MARKWIDTH, Width, nIndex);}

inline  LONG CTList::MarkWidth(int nIndex)
{ return GetNumProperty(IPROP_TLIST_MARKWIDTH, nIndex);}

inline  BOOL CTList::AutoExpand(int Mode)
{ return SetNumProperty(IPROP_TLIST_AUTOEXPAND, Mode);}

inline  int CTList::AutoExpand()
{ return int(GetNumProperty(IPROP_TLIST_AUTOEXPAND));}

inline  BOOL CTList::TreeLinesStyle(int Style)
{ return SetNumProperty(IPROP_TLIST_TREELINESSTYLE, Style);}

inline  int CTList::TreeLinesStyle()
{ return int(GetNumProperty(IPROP_TLIST_TREELINESSTYLE));}

inline  BOOL CTList::PicInMultiLine(int Style)
{ return SetNumProperty(IPROP_TLIST_PICINMULTILINE, Style);}

inline  int CTList::PicInMultiLine()
{ return int(GetNumProperty(IPROP_TLIST_PICINMULTILINE));}

inline  BOOL CTList::ShowCaption(int Mode)
{ return SetNumProperty(IPROP_TLIST_SHOWCAPTION, Mode);}

inline  int CTList::ShowCaption()
{ return int(GetNumProperty(IPROP_TLIST_SHOWCAPTION));}

inline  BOOL CTList::Caption(CString &Text)
{ return SetStrProperty(IPROP_TLIST_CAPTION, Text);}

inline  CString CTList::Caption()
{ return GetStrProperty(IPROP_TLIST_CAPTION);}

inline  BOOL CTList::ShowTitles(int Mode)
{ return SetNumProperty(IPROP_TLIST_SHOWTITLES, Mode);}

inline  int CTList::ShowTitles()
{ return int(GetNumProperty(IPROP_TLIST_SHOWTITLES));}

inline  BOOL CTList::TitlePicture(int nIndex, HPIC hpic)
{ return SetPictureProperty(IPROP_TLIST_TITLEPICTURE, hpic);}

inline  HPIC CTList::TitlePicture(int nIndex)
{ return GetPictureProperty(IPROP_TLIST_TITLEPICTURE);}

inline  BOOL CTList::TitleText(int nIndex, CString &Text)
{ return SetStrProperty(IPROP_TLIST_TITLETEXT, Text, nIndex);}

inline  CString CTList::TitleText(int nIndex)
{ return GetStrProperty(IPROP_TLIST_TITLETEXT, nIndex);}

inline  BOOL CTList::TitleVisible(int Style)
{ return SetNumProperty(IPROP_TLIST_TITLEVISIBLE, Style);}

inline  int CTList::TitleVisible()
{ return int(GetNumProperty(IPROP_TLIST_TITLEVISIBLE));}

inline  BOOL CTList::TitleWidth(int nIndex, LONG Width)
{ return SetNumProperty(IPROP_TLIST_TITLEWIDTH, Width, nIndex);}

inline  LONG CTList::TitleWidth(int nIndex)
{ return GetNumProperty(IPROP_TLIST_TITLEWIDTH, nIndex);}

inline  BOOL CTList::TitleHeight(int nIndex, LONG Height)
{ return SetNumProperty(IPROP_TLIST_TITLEHEIGHT, Height, nIndex);}

inline  LONG CTList::TitleHeight(int nIndex)
{ return GetNumProperty(IPROP_TLIST_TITLEHEIGHT, nIndex);}

inline  BOOL CTList::XOffset(LONG Offset)
{ return SetNumProperty(IPROP_TLIST_XOFFSET, Offset);}

inline  LONG CTList::XOffset()
{ return GetNumProperty(IPROP_TLIST_XOFFSET);}

inline  BOOL CTList::Indent(int nIndex, int Value)
{ return SetNumProperty(IPROP_TLIST_INDENT, Value, nIndex);}

inline  int CTList::Indent(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_INDENT, nIndex));}

inline  BOOL CTList::MSOutlineAdd(BOOL Style)
{ return SetNumProperty(IPROP_TLIST_MSOUTLINEADD, Style);}

inline  BOOL CTList::MSOutlineAdd()
{ return BOOL(GetNumProperty(IPROP_TLIST_MSOUTLINEADD));}

inline  int CTList::ListCountEx(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_LISTCOUNTEX, nIndex));}

inline  BOOL CTList::SelectEx(int nIndex, BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_SELECTEX, Mode, nIndex);}

inline  BOOL CTList::ExpandEx(int nIndex, BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_EXPANDEX, Mode, nIndex);}

inline  int CTList::SelItemCount()
{ return int(GetNumProperty(IPROP_TLIST_SELITEMCOUNT));}

inline  int CTList::SelItemIndex(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_SELITEMINDEX, nIndex));}

inline  LONG CTList::ItemBM(int nIndex)
{ return GetNumProperty(IPROP_TLIST_ITEMBM, nIndex);}

inline  BOOL CTList::CurrentItemBM(int nIndex, LONG BookMark)
{ return SetNumProperty(IPROP_TLIST_CURRENTITEMBM, BookMark, nIndex);}

inline  LONG CTList::CurrentItemBM(int nIndex)
{ return GetNumProperty(IPROP_TLIST_CURRENTITEMBM, nIndex);}

inline  int CTList::NewIndex()
{ return int(GetNumProperty(IPROP_TLIST_NEWINDEX));}

inline  BOOL CTList::BackwardCompatibility(BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_BACKWARDCOMPATIBILITY, Mode);}

inline  BOOL CTList::BackwardCompatibility()
{ return BOOL(GetNumProperty(IPROP_TLIST_BACKWARDCOMPATIBILITY));}

inline  BOOL CTList::File(int FileHandle, int Mode)
{ return SetNumProperty(IPROP_TLIST_FILE, Mode, FileHandle);}

inline  BOOL CTList::ExpandChildren(BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_EXPANDCHILDREN, Mode);}

inline  BOOL CTList::ExpandChildren()
{ return BOOL(GetNumProperty(IPROP_TLIST_EXPANDCHILDREN));}

inline  BOOL CTList::ExpandNewItem(int nIndex, BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_EXPANDNEWITEM, Mode, nIndex);}

inline  BOOL CTList::ExpandNewItem(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_EXPANDNEWITEM, nIndex));}

inline  LONG CTList::CopyOne(int nIndex)
{ return GetNumProperty(IPROP_TLIST_COPYONE, nIndex);}

inline  BOOL CTList::SaveOne(int nIndex, int FileHandle)
{ return SetNumProperty(IPROP_TLIST_SAVEONE, FileHandle, nIndex);}

inline  BOOL CTList::DragModeEx(int Mode)
{ return SetNumProperty(IPROP_TLIST_DRAGMODEEX, Mode);}

inline  int CTList::DragModeEx()
{ return int(GetNumProperty(IPROP_TLIST_DRAGMODEEX));}

inline  BOOL CTList::ItemSorted(int nIndex, int SortMode)
{ return SetNumProperty(IPROP_TLIST_ITEMSORTED, SortMode, nIndex);}

inline  int CTList::ItemSorted(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_ITEMSORTED, nIndex));}

inline  LONG CTList::ItemParentBM(int nIndex)
{ return GetNumProperty(IPROP_TLIST_ITEMPARENTBM, nIndex);}

inline  BOOL CTList::DefMultiLine(int nIndex, BOOL TextMode)
{ return SetNumProperty(IPROP_TLIST_DEFMULTILINE, TextMode, nIndex);}

inline  BOOL CTList::DefMultiLine(int nIndex)
{ return BOOL(GetNumProperty(IPROP_TLIST_DEFMULTILINE, nIndex));}

inline  BOOL CTList::ItemPMPicType(int nIndex, int PicType)
{ return SetNumProperty(IPROP_TLIST_ITEMPMPICTYPE, PicType, nIndex);}

inline  int CTList::ItemPMPicType(int nIndex)
{ return int(GetNumProperty(IPROP_TLIST_ITEMPMPICTYPE, nIndex));}

inline  BOOL CTList::WidthOfTextMin(float NewSize)
{ return SetFloatProperty(IPROP_TLIST_WIDTHOFTEXTMIN, NewSize);}

inline  float CTList::WidthOfTextMin()
{ return GetFloatProperty(IPROP_TLIST_WIDTHOFTEXTMIN);}

inline  BOOL CTList::SmartDragDrop(BOOL Mode)
{ return SetNumProperty(IPROP_TLIST_SMARTDRAGDROP, Mode);}

inline  BOOL CTList::SmartDragDrop()
{ return BOOL(GetNumProperty(IPROP_TLIST_SMARTDRAGDROP));}

#endif // TL30P_VC_H

